Subject: Re: bug#45260: 28.0.50; Maybe flex should only sort when there is no sorting metadata?

From: João Távora <[email-masked]>
Date: Tue, 28 Sep 2021 17:09:27 +0100

On Tue, Sep 28, 2021 at 1:38 PM Dmitry Gutov <[email-masked]> wrote:

> So the references to company-capf in that discussion are necessary, but
> incidental.

So it should be possible to describe the problem in simpler terms.  Which
is what I'm asking you to do.  In the simplest terms _possible_ of course.

> Since we're talking about a beginner learning the c-a-p-f API, saying
> "it is intended to work this way" is rather off base. I think the
> question is rather which choice will ultimately lead to less friction.
>
> While still leading to the expected behavior in all practical cases, of
> course.

Yes, and the expected behaviour is what happened.

It's not about the beginner developer here, it's about the user.
The beginner developer of the c-a-p-f API has to do more work
than the user to understand what the purpose is of the things
she is invoking.  If she invokes 'flex' in some program, she must
be aware of what she's doing, of how 'flex' works.

> >> You should read it (the last few messages will suffice).
> >
> > I tried to, it's full of references to company internals that I can't
> > evaluate.  Is the user writing a table specifically for company?  Or
> > modifying company?  Or both?  I must understand it in terms of a simpler
> > example.
>
> They're asking how to write a completion table which does sorting.
>
> It later turned out that they have the flex completion style set up in
> personal configuration. If you follow the discussion, you can note this
> conflict wasn't particularly easy to discover.
>
> And the practice of asking for "full reproduction starting with emacs
> -Q" in such threads feels fairly out of place.

I'm sorry.   We need a common ground to be able to communicate technical
problems.  I don't know if it's unfashionable in "such threads" but
I'm pretty sure
that you're accustomed to seeing such recipes in the Emacs bug tracker.

> But would it? Break existing behavior in any scenario that matters?

See my reply to Omar.

> > What is the problem with you telling those users to use 'pikachu'
> > instead of 'flex'?  Or tell them to set a hypothetical variable
> > flex-prefer-table-sorting to t?
>
> Discovery.

So you're talking about changing defaults.  But flex is not even the default,
so I don't understand.  Why are people using it if they're not content with
what it does?

Do a 'flix' style, as I've suggested multiple times! Look,  if you're right and
it represents much less friction it should rapidly become popular and your
burdens will be solved.  It probably take few lines of code.

> > I also suggest that people: "if you're writing a completion table, make
> > sure you try it without company as well".
> Not something I'm eager to recommend to somebody just starting out. It
> wouldn't help here either, I believe.

So you decide that it's a good idea for a beginner to mix company internals
into her adventures.... Questionable, I'd say.

João